/*
 * Copyright (C) 2005 Universitat d'Alacant / Universidad de Alicante
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */
#ifndef _ENTRYTOKEN_
#define _ENTRYTOKEN_

#include <string>
#include <list>

using namespace std;

class EntryToken
{
  enum Type {paradigm, single_transduction, regexp};
private:
  Type type;
  string parName;
  list<string> leftSide;
  list<string> rightSide;
  string myregexp;

  void copy(EntryToken const &e);
  void destroy();
public:
  EntryToken();
  ~EntryToken();
  EntryToken(EntryToken const &e);
  EntryToken & operator = (EntryToken const &e);
  void setParadigm(string const &np);
  void setSingleTransduction(list<string> const &pi, list<string> const &pd);
  void setRegExp(string const &r);
  bool isParadigm() const;
  bool isSingleTransduction() const;
  bool isRegExp() const;
  string const & paradigmName() const;
  list<string> const & left() const;
  list<string> const & right() const;
  string const & regExp() const;
};



#endif
